﻿using ProjectTrolleybus.Entities;
namespace ProjectTrolleybus.Drawnings;

/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawningTrolleyBCompareByColor : IComparer<DrawningTrolleyB?>
{
    public int Compare(DrawningTrolleyB? x, DrawningTrolleyB? y)
    {
        // TODO прописать логику сравнения по цветам, скорости, весу
        if (x == null || x.EntityTrolleyB == null)
        {
            return 1;
        }

        if (y == null || y.EntityTrolleyB == null)
        {
            return -1;
        }

        if (x.EntityTrolleyB.BodyColor != y.EntityTrolleyB.BodyColor)
        {
            return x.EntityTrolleyB.BodyColor.Name.CompareTo(y.EntityTrolleyB.BodyColor.Name);
        }

        var speedCompare = x.EntityTrolleyB.Speed.CompareTo(y.EntityTrolleyB.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTrolleyB.Weight.CompareTo(y.EntityTrolleyB.Weight);
    }
}
