﻿namespace ProjectTrolleybus.Drawnings;

/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawningTrolleyBCompareByType : IComparer<DrawningTrolleyB?>
{
    public int Compare(DrawningTrolleyB? x, DrawningTrolleyB? y)
    {
        if (x == null || x.EntityTrolleyB == null)
        {
            return 1;
        }

        if (y == null || y.EntityTrolleyB == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityTrolleyB.Speed.CompareTo(y.EntityTrolleyB.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTrolleyB.Weight.CompareTo(y.EntityTrolleyB.Weight);
    }
}
