﻿using System.Diagnostics.CodeAnalysis;
using ProjectTrolleybus.Entities;
namespace ProjectTrolleybus.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningTrolleyBEqutables : IEqualityComparer<DrawningTrolleyB?>
{
    public bool Equals(DrawningTrolleyB? x, DrawningTrolleyB? y)
    {
        if (x == null || x.EntityTrolleyB == null)
        {
            return false;
        }

        if (y == null || y.EntityTrolleyB == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityTrolleyB.Speed != y.EntityTrolleyB.Speed)
        {
            return false;
        }

        if (x.EntityTrolleyB.Weight != y.EntityTrolleyB.Weight)
        {
            return false;
        }

        if (x.EntityTrolleyB.BodyColor != y.EntityTrolleyB.BodyColor)
        {
            return false;
        }

        if (x is DrawningTrolleybus && y is DrawningTrolleybus)
        {
            // TODO доделать логику сравнения дополнительных параметров
            EntityTrolleybus xTrolleybus = (EntityTrolleybus)x.EntityTrolleyB;
            EntityTrolleybus yTrolleybus = (EntityTrolleybus)y.EntityTrolleyB;

            if (xTrolleybus.AdditionalColor != yTrolleybus.AdditionalColor)
            {
                return false;
            }

            if (xTrolleybus.BatteryCompartment != yTrolleybus.BatteryCompartment)
            {
                return false;
            }

            if (xTrolleybus.Horns != yTrolleybus.Horns)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawningTrolleyB obj)
    {
        return obj.GetHashCode();
    }
}
